<html>
<head>
<title>Ogre::RTShader::RenderState Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html">RenderState</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::RenderState Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::RenderState" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>This is a container class for sub render state class.  
 <a href="classOgre_1_1RTShader_1_1RenderState.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::RenderState:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1RenderState__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1RenderState_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1RenderState_inherit__map" id="Ogre_1_1RTShader_1_1RenderState_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1RTShader_1_1TargetRenderState.html" title="This is the target render state." alt="" coords="5,160,240,189"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="45,5,200,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1RenderState-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a9ad5c29c93f7e3852b2bf34ed7d71850">RenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class default constructor.  <a href="#a9ad5c29c93f7e3852b2bf34ed7d71850"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adbe4e95bc100df25fe3f860869ee53a1">~RenderState</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#adbe4e95bc100df25fe3f860869ee53a1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ca983d7872dd4af086d73f1685188f1">reset</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Reset this render state.  <a href="#a0ca983d7872dd4af086d73f1685188f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#af66edaf33c654e03ef89f1eaec384a1f">addTemplateSubRenderState</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Add a template sub render state to this render state.  <a href="#af66edaf33c654e03ef89f1eaec384a1f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adf57c1505668d7cd9fc65c33231ee3ff">removeTemplateSubRenderState</a> (<a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *subRenderState)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove a template sub render state from this render state.  <a href="#adf57c1505668d7cd9fc65c33231ee3ff"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a">getTemplateSubRenderStateList</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the list of the template sub render states composing this render state.  <a href="#a3156a7f08feecf6c0df8c2ec28d7e28a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8">setLightCount</a> (const int lightCount[3])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the light count per light type.  <a href="#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a1b891435cd80949d502ad448f8a203cf">getLightCount</a> (int lightCount[3]) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the light count per light type.  <a href="#a1b891435cd80949d502ad448f8a203cf"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877">setLightCountAutoUpdate</a> (bool autoUpdate)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the light count auto update state.  <a href="#acd05f1eaf224a41f89b4c94823b96877"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb">getLightCountAutoUpdate</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return true if this render state override the light count.  <a href="#a79777c200ca66ffe77b03f3462cbddbb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">mSubRenderStateList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a969c088c5e51a22c211c535375d139a8">mLightCount</a> [3]</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">mLightCountAutoUpdate</a></td></tr>
<tr><td colspan="2"><h2><a name="friends"></a>
Friends</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">ProgramManager</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">FFPRenderStateBuilder</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is a container class for sub render state class. </p>
<p>A render state is defined by the sub render states that compose it. The user should use this interface to define global or per material custom behavior. I.E In order to apply per pixel to a specific material one should implement a sub class of <a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html" title="This class is the base interface of sub part from a shader based rendering pipeline.">SubRenderState</a> that perform a per pixel lighting model, get the render state of the target material and add the custom sub class to it. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00050">50</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9ad5c29c93f7e3852b2bf34ed7d71850"></a><!-- doxytag: member="Ogre::RTShader::RenderState::RenderState" ref="a9ad5c29c93f7e3852b2bf34ed7d71850" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a9ad5c29c93f7e3852b2bf34ed7d71850">Ogre::RTShader::RenderState::RenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class default constructor. </p>

</div>
</div>
<a class="anchor" id="adbe4e95bc100df25fe3f860869ee53a1"></a><!-- doxytag: member="Ogre::RTShader::RenderState::~RenderState" ref="adbe4e95bc100df25fe3f860869ee53a1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adbe4e95bc100df25fe3f860869ee53a1">Ogre::RTShader::RenderState::~RenderState</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="af66edaf33c654e03ef89f1eaec384a1f"></a><!-- doxytag: member="Ogre::RTShader::RenderState::addTemplateSubRenderState" ref="af66edaf33c654e03ef89f1eaec384a1f" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#af66edaf33c654e03ef89f1eaec384a1f">Ogre::RTShader::RenderState::addTemplateSubRenderState</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Add a template sub render state to this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state template to add. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1b891435cd80949d502ad448f8a203cf"></a><!-- doxytag: member="Ogre::RTShader::RenderState::getLightCount" ref="a1b891435cd80949d502ad448f8a203cf" args="(int lightCount[3]) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a1b891435cd80949d502ad448f8a203cf">Ogre::RTShader::RenderState::getLightCount</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>lightCount</em>[3]</td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the light count per light type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightCount</td><td>The light count per type. lightCount[0] defines the point light count. lightCount[1] defines the directional light count. lightCount[2] defines the spot light count. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a79777c200ca66ffe77b03f3462cbddbb"></a><!-- doxytag: member="Ogre::RTShader::RenderState::getLightCountAutoUpdate" ref="a79777c200ca66ffe77b03f3462cbddbb" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a79777c200ca66ffe77b03f3462cbddbb">Ogre::RTShader::RenderState::getLightCountAutoUpdate</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return true if this render state override the light count. </p>
<p>If light count is not overridden it will be updated from the shader generator based on current scene lights. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00110">110</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3156a7f08feecf6c0df8c2ec28d7e28a"></a><!-- doxytag: member="Ogre::RTShader::RenderState::getTemplateSubRenderStateList" ref="a3156a7f08feecf6c0df8c2ec28d7e28a" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a3156a7f08feecf6c0df8c2ec28d7e28a">Ogre::RTShader::RenderState::getTemplateSubRenderStateList</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the list of the template sub render states composing this render state. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00076">76</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::RenderState::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="adf57c1505668d7cd9fc65c33231ee3ff"></a><!-- doxytag: member="Ogre::RTShader::RenderState::removeTemplateSubRenderState" ref="adf57c1505668d7cd9fc65c33231ee3ff" args="(SubRenderState *subRenderState)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#adf57c1505668d7cd9fc65c33231ee3ff">Ogre::RTShader::RenderState::removeTemplateSubRenderState</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1SubRenderState.html">SubRenderState</a> *&#160;</td>
          <td class="paramname"><em>subRenderState</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Remove a template sub render state from this render state. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">subRenderState</td><td>The sub render state to remove. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0ca983d7872dd4af086d73f1685188f1"></a><!-- doxytag: member="Ogre::RTShader::RenderState::reset" ref="a0ca983d7872dd4af086d73f1685188f1" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ca983d7872dd4af086d73f1685188f1">Ogre::RTShader::RenderState::reset</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reset this render state. </p>

</div>
</div>
<a class="anchor" id="a7d4bfe3ddbb10a94ae9e84d24fdcb5d8"></a><!-- doxytag: member="Ogre::RTShader::RenderState::setLightCount" ref="a7d4bfe3ddbb10a94ae9e84d24fdcb5d8" args="(const int lightCount[3])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a7d4bfe3ddbb10a94ae9e84d24fdcb5d8">Ogre::RTShader::RenderState::setLightCount</a> </td>
          <td>(</td>
          <td class="paramtype">const int&#160;</td>
          <td class="paramname"><em>lightCount</em>[3]</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the light count per light type. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightCount</td><td>The light count per type. lightCount[0] defines the point light count. lightCount[1] defines the directional light count. lightCount[2] defines the spot light count. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="acd05f1eaf224a41f89b4c94823b96877"></a><!-- doxytag: member="Ogre::RTShader::RenderState::setLightCountAutoUpdate" ref="acd05f1eaf224a41f89b4c94823b96877" args="(bool autoUpdate)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#acd05f1eaf224a41f89b4c94823b96877">Ogre::RTShader::RenderState::setLightCountAutoUpdate</a> </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>autoUpdate</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the light count auto update state. </p>
<p>If the value is false the light count will remain static for the values that were set by the user. If the value is true the light count will be updated from the owner shader generator scheme based on current scene lights. The default is true. </p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00104">104</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Friends And Related Function Documentation</h2>
<a class="anchor" id="a0ebb9db4c085496981b7dbdd61f34fc9"></a><!-- doxytag: member="Ogre::RTShader::RenderState::FFPRenderStateBuilder" ref="a0ebb9db4c085496981b7dbdd61f34fc9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">FFPRenderStateBuilder</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#a0ebb9db4c085496981b7dbdd61f34fc9">Ogre::RTShader::TargetRenderState</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00123">123</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae46e120edae3a1f22dc68ebde7fbcfca"></a><!-- doxytag: member="Ogre::RTShader::RenderState::ProgramManager" ref="ae46e120edae3a1f22dc68ebde7fbcfca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">friend class <a class="el" href="classOgre_1_1RTShader_1_1ProgramManager.html">ProgramManager</a><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Reimplemented in <a class="el" href="classOgre_1_1RTShader_1_1TargetRenderState.html#ae46e120edae3a1f22dc68ebde7fbcfca">Ogre::RTShader::TargetRenderState</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00122">122</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a969c088c5e51a22c211c535375d139a8"></a><!-- doxytag: member="Ogre::RTShader::RenderState::mLightCount" ref="a969c088c5e51a22c211c535375d139a8" args="[3]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a969c088c5e51a22c211c535375d139a8">Ogre::RTShader::RenderState::mLightCount</a>[3]<code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00118">118</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa36a91213f0c16fc4b68893911ad4f1e"></a><!-- doxytag: member="Ogre::RTShader::RenderState::mLightCountAutoUpdate" ref="aa36a91213f0c16fc4b68893911ad4f1e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#aa36a91213f0c16fc4b68893911ad4f1e">Ogre::RTShader::RenderState::mLightCountAutoUpdate</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00119">119</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<a class="anchor" id="a60de670ecb16e42e97f9bf8265270ea7"></a><!-- doxytag: member="Ogre::RTShader::RenderState::mSubRenderStateList" ref="a60de670ecb16e42e97f9bf8265270ea7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga279d48a1cabb619e85aba3c931e71b33">SubRenderStateList</a> <a class="el" href="classOgre_1_1RTShader_1_1RenderState.html#a60de670ecb16e42e97f9bf8265270ea7">Ogre::RTShader::RenderState::mSubRenderStateList</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderRenderState_8h_source.html#l00117">117</a> of file <a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderRenderState_8h_source.html">OgreShaderRenderState.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:33
</p>
</body>
</html>
